module CabezaDeTermo
	module Lunfardo
		module Behaviour
			def self.included(base_class)
				base_class.extend ClassMethods
			end

			module ClassMethods
				def dsl(&block)
					@root_scope = new_root_scope(&block)
					@root_scope.instance_eval(&block)
				end

				def new_root_scope(&block)
					Lunfardo::Scope.new_scope_class(name: :root_scope, &block)
				end

				def evaluate(&block)
					evaluate_on(nil, &block)
				end

				def evaluate_on(context, &block)
					@root_scope.new(context, nil)._evaluate(&block)
				end
			end
		end
	end
end
